#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int main(){
    freopen ("labirint.in", "r", stdin);
    freopen ("labirint.out", "w", stdout);

    int n, m;
    pair <int, int> start, finish = make_pair(-1, -1);
    vector < vector <int> > Lab;
    vector <char> Way;

    scanf("%d%d", &m, &n);
    Lab.resize (m);

    for (int i = 0; i<m; i++){
        Lab[i].resize(n);
        char ch;
        scanf("%c", &ch);
        for (int j = 0; j<n; j++) {
            scanf("%c", &ch);
            if (ch == '+') {
                Lab[i][j] = 1;
                start = make_pair(i,j);
            } else
                if (ch == ' ') Lab[i][j] = 0;
                    else Lab[i][j] = 1000000000;
        }
    }

    int point = 0;
    vector <pair <int, int> > Queue(1, start);

    while (point < Queue.size()){
        pair <int, int> now = Queue[point];

        if ((now.first == 0) || (now.first == m-1) || (now.second == 0) || (now.second == n-1)){
            finish = make_pair(now.first, now.second);
            break;
        }

        if (Lab[now.first + 1][now.second] == 0) {
            Lab[now.first + 1][now.second] = Lab[now.first][now.second]+1;
            Queue.push_back(make_pair(now.first + 1, now.second));
        }
        if (Lab[now.first - 1][now.second] == 0) {
            Lab[now.first - 1][now.second] = Lab[now.first][now.second]+1;
            Queue.push_back(make_pair(now.first - 1, now.second));
        }
        if (Lab[now.first][now.second + 1] == 0) {
                Lab[now.first][now.second + 1] = Lab[now.first][now.second]+1;
                Queue.push_back(make_pair(now.first, now.second + 1));
        }
        if (Lab[now.first][now.second - 1] == 0) {
            Lab[now.first][now.second - 1] = Lab[now.first][now.second]+1;
            Queue.push_back(make_pair(now.first, now.second - 1));
        }

        point++;
    }

    if (finish.first == -1){
        printf("-1\n");
        return 0;
    }

    printf("%d\n",Lab[finish.first][finish.second]-1);

    while (start != finish){
        int now = Lab[finish.first][finish.second] - 1;

        if (now == Lab[finish.first + 1][finish.second]) {
            Way.push_back('n');
            finish.first += 1;
        } else if (now == Lab[finish.first - 1][finish.second]) {
                Way.push_back('s');
                finish.first -= 1;
            } else if (now == Lab[finish.first][finish.second + 1]) {
                    Way.push_back('w');
                    finish.second += 1;
                } else if (now == Lab[finish.first][finish.second - 1]) {
                    Way.push_back('e');
                    finish.second -= 1;
                }
    }

    for (int i = Way.size()-1; i>=0; i--) printf("%c", Way[i]);


    return 0;
}
