/* GCC */
#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <stdio.h>
#include <algorithm>
#include <queue>
#include <sstream>

using namespace std;

#define f_in(s) freopen(s,"r",stdin)
#define f_out(s) freopen(s,"w",stdout)

vector <vector <int> > a;
const long long inf = 1e9;
bool f = 0;
pair<int,int> start;
int n,m;
string ans = "";

void bfs(int x, int y)
{
    set<pair<pair<int,string>,pair<int,int> > > q;
    q.insert(make_pair(make_pair(0,""),make_pair(x,y)));
    while (!q.empty())
    {
        x = q.begin()->second.first;
        y = q.begin()->second.second;
        string s = q.begin()->first.second;
        q.erase(q.begin());
        if (x == n - 1 || y == m - 1 || y == 0 || x == 0)
        {
            f = 1;
            ans = s;
            return;
        }
        if (x - 1 >= 0 && a[x-1][y] != -1 && a[x-1][y] > s.size() + 1)
        {
            q.insert(make_pair(make_pair(s.size()+1,s+"n"),make_pair(x-1,y)));
            a[x-1][y] = s.size() + 1;
        }
        if (y - 1 >= 0 && a[x][y-1] != -1 && a[x][y-1] > s.size() + 1)
        {
            q.insert(make_pair(make_pair(s.size()+1,s+"w"),make_pair(x,y-1)));
            a[x][y-1] = s.size() + 1;
        }
        if (x + 1 < n && a[x+1][y] != -1 && a[x+1][y] > s.size() + 1)
        {
            q.insert(make_pair(make_pair(s.size()+1,s+"s"),make_pair(x+1,y)));
            a[x+1][y] = s.size() + 1;
        }
        if (y + 1 < m && a[x][y+1] != -1 && a[x][y+1] > s.size() + 1)
        {
            q.insert(make_pair(make_pair(s.size()+1,s+"e"),make_pair(x,y+1)));
            a[x][y+1] = s.size() + 1;
        }
    }
}

int main()
{
    f_in("labirint.in");
    f_out("labirint.out");
    cin >> n >> m;
    string s;
    getline(cin,s);
    a.assign(n,vector <int> (m));
    for (int i = 0; i < n; i++)
    {
        getline(cin,s);
        while (s.size() != m) s+= ' ';
        for (int j = 0; j < m; j++)
        {
            if (s[j] == '+')
            {
                start = make_pair(i,j);
                a[i][j] = 0;
            }
            else if (s[j] == ' ') a[i][j] = inf;
            else a[i][j] = -1;
        }
    }
    bfs(start.first,start.second);
    if (f && ans.size() != 0) cout << ans.size() << '\n' << ans << '\n';
    else if (f) cout << 0 << '\n';
    else cout << -1 << '\n';
}
