/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>

#define X first
#define Y second

using namespace std;
int n, m;
vector<vector<char> > in;
vector<vector<int> > f;
vector< pair<int, int> > line;
pair<int, int> start;

void readData(){
    freopen("labirint.in", "r", stdin);

    scanf("%d %d\n", &m, &n);
    in.assign(m, vector<char> (n));
    f.assign(m, vector<int> (n, -1));
    char c;
    for(int i=0; i<m; i++){
        for(int z=0; z<n; z++){
            c=getchar();
            if(c=='+' || c==' ') in[i][z]=c;
            else in[i][z]='#';
        }
        c=getchar();
    }

    fclose(stdin);
}

void solve(){
    for(int i=0; i<m; i++){
        if(in[i][0]!='#') {
            f[i][0]=0;
            line.push_back( make_pair(i, 0) );
        }
        if(in[i][n-1]!='#') {
            f[i][n-1]=0;
            line.push_back( make_pair(i, n-1) );
        }
    }
    for(int i=0; i<n; i++){
        if(in[0][i]!='#') {
            f[0][i]=0;
            line.push_back( make_pair(0, i) );
        }
        if(in[m-1][i]!='#') {
            f[m-1][i]=0;
            line.push_back( make_pair(m-1, i) );
        }
    }
    bool found=false;
    for(int i=0; i<m && !found; i++){
        for(int z=0; z<n && !found; z++){
            if(in[i][z]=='+') {
                start=make_pair(i, z);
                found=true;
            }
        }
    }
    while(f[start.X][start.Y]==-1 && !line.empty()){
        int x=line[0].X, y=line[0].Y;
        line.erase(line.begin());
        if(x>0 && in[x-1][y]!='#' && f[x-1][y]==-1){
            f[x-1][y]=f[x][y]+1;
            line.push_back(make_pair(x-1, y));
        }
        if(y>0 && in[x][y-1]!='#' && f[x][y-1]==-1){
            f[x][y-1]=f[x][y]+1;
            line.push_back(make_pair(x, y-1));
        }
        if(x<m-1 && in[x+1][y]!='#' && f[x+1][y]==-1){
            f[x+1][y]=f[x][y]+1;
            line.push_back(make_pair(x+1, y));
        }
        if(y<n-1 && in[x][y+1]!='#' && f[x][y+1]==-1){
            f[x][y+1]=f[x][y]+1;
            line.push_back(make_pair(x, y+1));
        }
    }
}

void fileOut(){
    freopen("labirint.out", "w", stdout);

    int x=start.X, y=start.Y, left=f[x][y];
    printf("%d\n", left);
    if(left!=-1 && left!=0){
        while(left){
            if(x>0 && f[x-1][y]==f[x][y]-1){
                x--;
                left--;
                printf("n");
                continue;
            }
            if(y>0 && f[x][y-1]==f[x][y]-1){
                y--;
                left--;
                printf("w");
                continue;
            }
            if(x<m-1 && f[x+1][y]==f[x][y]-1){
                x++;
                left--;
                printf("s");
                continue;
            }
            if(y<n-1 && f[x][y+1]==f[x][y]-1){
                y++;
                left--;
                printf("e");
                continue;
            }
        }
        printf("\n");
    }

    fclose(stdout);
}

int main(){
    readData();
    solve();
    fileOut();
    return 0;
}
