#include<iostream>
#include<vector>
#include<queue>
#include<cstdio>
#include<algorithm>
#define point pair<int, int>
#define x first
#define y second

using namespace std;

int n, m;
point start;

int main(){
    freopen("labirint.in", "r", stdin);
    freopen("labirint.out", "w", stdout);
    cin >> n >> m;
    vector< vector<int> > arr(n, vector<int>(m));
    string line;
    getline(cin, line);
    for(int i = 0; i < n; ++i){
        getline(cin, line);
        for(int j = 0; j < m; ++j){
            char c = line[j];
            if(c == '+'){
                start.x = i;
                start.y = j;
                arr[i][j] = 1;
                continue;
            }
            if(c == ' '){
                continue;
            }
            arr[i][j] = -1;
        }
    }
    queue<point> q;
    q.push(start);
    point finish(-1, -1);
    while(!q.empty()){
        point p = q.front();
        q.pop();
        if(p.x == 0 || p.x == n-1 || p.y == 0 || p.y == m-1){
            finish = p;
            break;
        }
        int num = arr[p.x][p.y];
        if(!arr[p.x+1][p.y]){
            arr[p.x+1][p.y] = num+1;
            q.push(point(p.x+1, p.y));
        }
        if(!arr[p.x-1][p.y]){
            arr[p.x-1][p.y] = num+1;
            q.push(point(p.x-1, p.y));
        }
        if(!arr[p.x][p.y+1]){
            arr[p.x][p.y+1] = num+1;
            q.push(point(p.x, p.y+1));
        }
        if(!arr[p.x][p.y-1]){
            arr[p.x][p.y-1] = num+1;
            q.push(point(p.x, p.y-1));
        }
    }
    if(finish.x == -1){
        cout << "-1\n";
        return 0;
    }
    cout << arr[finish.x][finish.y]-1 << endl;
    if(arr[finish.x][finish.y] == 1) return 0;
    point pos = finish;
    string ans;
    while(pos != start){
        int num = arr[pos.x][pos.y];
        if(pos.x-1 >= 0 && arr[pos.x-1][pos.y] == num-1){
            pos = point(pos.x-1, pos.y);
            ans.push_back('s');
            continue;
        }
        if(pos.x+1 < n && arr[pos.x+1][pos.y] == num-1){
            pos = point(pos.x+1, pos.y);
            ans.push_back('n');
            continue;
        }
        if(pos.y-1 >= 0 && arr[pos.x][pos.y-1] == num-1){
            pos = point(pos.x, pos.y-1);
            ans.push_back('e');
            continue;
        }
        if(pos.y+1 < n && arr[pos.x][pos.y+1] == num-1){
            pos = point(pos.x, pos.y+1);
            ans.push_back('w');
            continue;
        }
    }
    reverse(ans.begin(), ans.end());
    cout << ans << endl;
}
