#include <bits/stdc++.h>

using namespace std;

struct pnt {
    int i, j;
};

vector< vector<pnt> > pr;
vector< vector<bool> > used;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    freopen("labirint.in", "r", stdin);
    freopen("labirint.out", "w", stdout);

    int n, m;
    pnt s;
    string hS;
    char hV;
    cin >> n >> m;
    used.resize(n);
    pr.resize(n);

    getline(cin, hS);
    for(int i = 0;i < n;++i) {
        getline(cin, hS);
    for(int j = 0;j < m;++j) {
        hV = hS[j];
        used[i].push_back(hV != ' ');
        pr[i].push_back({-1, -1});
        if(hV == '+')
            s = {i, j};
    }
    }

    pnt last = {-1, -1};
    queue<pnt> q;
    q.push(s);
    while(!q.empty()) {
        pnt v = q.front();
        q.pop();
        if(v.i == 0 || v.i == n-1 || v.j == 0 || v.j == m-1) {
            last = v;
            break;
        }
        if(!used[v.i-1][v.j]){
            pr[v.i-1][v.j] = v;
            used[v.i-1][v.j] = true;
            q.push({v.i-1, v.j});
        }
        if(!used[v.i+1][v.j]){
            pr[v.i+1][v.j] = v;
            used[v.i+1][v.j] = true;
            q.push({v.i+1, v.j});
        }
        if(!used[v.i][v.j-1]){
            pr[v.i][v.j-1] = v;
            used[v.i][v.j-1] = true;
            q.push({v.i, v.j-1});
        }
        if(!used[v.i][v.j+1]){
            pr[v.i][v.j+1] = v;
            used[v.i][v.j+1] = true;
            q.push({v.i, v.j+1});
        }
    }
    if(last.i == -1) {
        cout << "-1\n";
        return 0;
    }
    string str = "";
    while(pr[last.i][last.j].i != -1) {
        pnt hV = pr[last.i][last.j];
        if(hV.i < last.i)
            str+='s';
        if(hV.i > last.i)
            str+='n';
        if(hV.j < last.j)
            str+='e';
        if(hV.j > last.j)
            str+='w';
        last = hV;
    }
    reverse(str.begin(), str.end());
    cout << str.size() << '\n';
    cout << str << '\n';
    return 0;
}
