#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>

typedef long long Tlong;

using namespace std;

const int inf = 1000000007;

long long nsk(long long a, long long b){
    long long gcd = __gcd(a,b);
    a/= gcd;
    b/= gcd;
    return a*b*gcd;
}

void print_Tlong(Tlong a){
    cout << a << "\n";
}

void new_Tlong(Tlong &a, int b){
    a = (long long) b;
}

int main(){
    freopen("common.in","r",stdin);
    freopen("common.out","w",stdout);
    int n;
    Tlong com, d;
    int a, d1, temp = 0;
    cin >> n;
    cin >> temp >> d;
    new_Tlong(com,temp);
    for(int i = 1; i < n; i++){
        cin >> a >> d1;
        if(d == 0 && d1 == 0){
            if(!(com == a)){
                cout << 0 << "\n";
                return 0;
            }
        }
        else if(d == 0 && com >= a){
            temp = com % d1;
            if(a%d1 != temp){
                cout << 0 << "\n";
                return 0;
            }
        }
        else if(d1 == 0 && com <= a){
            temp = com % d;
            if(a%d != temp){
                cout << 0 << "\n";
                return 0;
            }
            new_Tlong(com,a);
            com = a;
            d = 0;
        }
        else {
            while(com < a) com += d;
            com -= a;
            int temp = com % d1;
            if(temp == 0){
                com += a;
                d = nsk(d,d1);
                continue;
            }
            com += d;
            while(com%d1 != 0 && com%d1 != temp){
                com += d;
            }
            if(com%d1 == temp && com%d1 != 0){
                cout << 0 << endl;
                return 0;
            }
            else{
                temp = com/d1;
                com += a;
                d = nsk(d,d1);
            }
        }
    }
    print_Tlong(com);
    return 0;
}
