/* GCC */
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>

using namespace std;

#define pll pair<long long,long long>
#define a first
#define d second
#define mp make_pair
#define pb push_back

vector <pll> progressions;



long long n;

long long gcd(long long a,long long b)
{
    while(b)
    {
        a%=b;
        swap(a,b);
    }
    return a;
}

pll find_new_progression()
{
    long long a1 = progressions[0].a, d1 = progressions[0].d, a2 = progressions[1].a, d2 = progressions[1].d;
    if (d1 == 0&&d2 == 0){
        if (a1 == a2) return mp(a1,0);
            else return mp(-1,-1);
    }
    if (d1 == 0){
        if (a1 >= a2&&(a1 - a2) % d2 == 0) return mp(a1,0);
            else return mp(-1,-1);
    }
    if (d2 == 0){
        if (a2 >= a1&&(a2 - a1) % d1 == 0) return mp(a2,0);
        else return mp(-1,-1);
    }
    if ((max(a1,a2) - min(a1,a2))%gcd(d1,d2) == 0){
        pll neu;
        long long k;
        if (a1 < a2){
            swap(a1,a2);
            swap(d1,d2);
        }
        for (long long i = 1;i < d2+3;i++)
            if ((a1 + (i-1)*d1 - a2)%d2 == 0){
                k = i;
                break;
        }
        neu.a = a1 + (k-1)*d1;
        neu.d = d1*d2/gcd(d1,d2);
        return neu;
    }
    return mp(-1,-1);
}

int main()
{
    freopen("common.in","r",stdin);
    freopen("common.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin>>n;
    for (long i = 0;i < n;i++)
    {
        pll temp;
        cin>>temp.a>>temp.d;
        progressions.pb(temp);
    }
    while(progressions.size() > 1)
    {
        pll temp = find_new_progression();
        if (temp.a == -1){
            cout<<0<<'\n';
            return 0;
        }
        progressions.pb(temp);
        progressions.erase(progressions.begin());
        progressions.erase(progressions.begin());
    }
    cout<<progressions[0].a<<'\n';

    return 0;
}
