/* GCC */
#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>
#include <map>

using namespace std;

#define pll pair<long long,long long>
#define x first
#define y second
#define mp make_pair
#define pb push_back

const long inf = 99999999;

string str;
vector <vector <bool> > fld,used;
vector <vector <long> > dist;
vector <pll> way;
map <pll,pll> from;
pll start,finish = mp(-1,-1);
long long n,m;

void bfs()
{
    used[start.x][start.y] = 1;
    from[start] = start;
    queue <pll> q;
    q.push(start);
    while(!q.empty())
    {
        pll v = q.front();
        q.pop();
        dist[start.x][start.y] = 0;
        if (v.x > 0&&fld[v.x-1][v.y]&&!used[v.x-1][v.y]){
            pll to = mp(v.x-1,v.y);
            dist[to.x][to.y] = dist[v.x][v.y] + 1;
            from[to] = v;
            if (to.x == 0||to.y == 0||to.x == n-1||to.y == m-1){
                finish = to;
                return;
            }
            used[to.x][to.y] = 1;
            q.push(to);
        }
        if (v.x < n-1&&fld[v.x+1][v.y]&&!used[v.x+1][v.y]){
            pll to = mp(v.x+1,v.y);
            dist[to.x][to.y] = dist[v.x][v.y] + 1;
            from[to] = v;
            if (to.x == 0||to.y == 0||to.x == n-1||to.y == m-1){
                finish = to;
                return;
            }
            used[to.x][to.y] = 1;
            q.push(to);
        }
        if (v.y < m-1&&fld[v.x][v.y+1]&&!used[v.x][v.y+1]){
            pll to = mp(v.x,v.y+1);
            dist[to.x][to.y] = dist[v.x][v.y] + 1;
            from[to] = v;
            if (to.x == 0||to.y == 0||to.x == n-1||to.y == m-1){
                finish = to;
                return;
            }
            used[to.x][to.y] = 1;
            q.push(to);
        }
        if (v.y > 0&&fld[v.x][v.y-1]&&!used[v.x][v.y-1]){
            pll to = mp(v.x,v.y-1);
            dist[to.x][to.y] = dist[v.x][v.y] + 1;
            from[to] = v;
            if (to.x == 0||to.y == 0||to.x == n-1||to.y == m-1){
                finish = to;
                return;
            }
            used[to.x][to.y] = 1;
            q.push(to);
        }

    }
}

void vyv(pll a,pll b)
{
    if (a.x > b.x) {
        cout<<'n';
        return;
    }
    if (a.x < b.x) {
        cout<<'s';
        return;
    }
    if (a.y < b.y) {
        cout<<'e';
        return;
    }
    cout<<'w';
    return;
}

int main()
{
    freopen("labirint.in","r",stdin);
    freopen("labirint.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n >> m;
    fld.assign(n+1,vector <bool> (m+1,0));
    used.assign(n+1,vector <bool> (m+1,0));
    dist.assign(n+1,vector <long> (m+1,inf));
    getline(cin,str);
    for (long i = 0;i < n;i++)
    {
        getline(cin,str);
        for (long j = 0;j < m;j++)
            if (str[j] == ' ') fld[i][j] = 1;
            else if (str[j] == '+') {
                start.x = i;
                start.y = j;
                fld[i][j] = 1;
            }
    }

    bfs();
    if (finish.x == -1){
        cout<<-1<<'\n';
        return 0;
    }
    cout << dist[finish.x][finish.y]<<'\n';
    way.pb(finish);
    while(finish!=from[finish])
    {
        finish = from[finish];
        way.pb(finish);
    }
    for (long i = way.size() - 2;i >= 0;i--)
        vyv(way[i+1],way[i]);
    cout<<'\n';
    return 0;
}
