/* GCC */
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <list>
#include <set>
#include <cstdio>
#include <map>

using namespace std;
#define MAXN 10005
#define mp(i, j) make_pair((i), (j))

int m, n, arr[MAXN];
pair <int, int> dp[MAXN];
char ans[MAXN];

int main() {
    freopen("labirint.in", "r", stdin);
    freopen("labirint.out", "w", stdout);

    scanf("%d%d", &m, &n);

    int i, j;

    char ch, str[MAXN];
    gets(str);

    int curx, cury;

    for (i = 0; i < m; ++i) {
        for (j = 0; j < n; ++j) {
            scanf("%c", &ch);

            if (ch == ' ') arr[i * n + j] = -1;
            else if (ch == '+') {
                    arr[i * n + j] = 0;
                    curx = i;
                    cury = j;
                 } else arr[i * n + j] = -2;
        }
        gets(str);
    }

    int lef = 0, righ = 1;

    dp[0] = mp(curx, cury);
    curx = -1;

    while (lef != righ) {
        i = dp[lef].first;
        j = dp[lef].second;
        ++lef;
        if (!i || i == m - 1 || !j || j == n - 1) {
            curx = i;
            cury = j;
            break;
        }

        if (arr[(i - 1) * n + j] == -1) {
            dp[righ] = mp(i - 1, j);
            ++righ;
            arr[(i - 1) * n + j] = arr[i * n + j] + 1;
        }

        if (arr[(i + 1) * n + j] == -1) {
            dp[righ] = mp(i + 1, j);
            ++righ;
            arr[(i + 1) * n + j] = arr[i * n + j] + 1;
        }

        if (arr[i * n + (j - 1)] == -1) {
            dp[righ] = mp(i, j - 1);
            ++righ;
            arr[i * n + (j - 1)] = arr[i * n + j] + 1;
        }

        if (arr[i * n + (j + 1)] == -1) {
            dp[righ] = mp(i, j + 1);
            ++righ;
            arr[i * n + (j + 1)] = arr[i * n + j] + 1;
        }
    }

    if (curx == -1) {
        printf("-1\n");
        return 0;
    }

    int cur = arr[curx * n + cury];
    printf("%d\n", cur);
    if (!cur) return 0;

    for (i = cur - 1; i >= 0; --i) {
        if (curx > 0 && arr[(curx - 1) * n + cury] == (arr[curx * n + cury] - 1)) {
            ans[i] = 's';
            curx--;
            continue;
        }

        if (curx < (m - 1) && arr[(curx + 1) * n + cury] == (arr[curx * n + cury] - 1)) {
            ans[i] = 'n';
            curx++;
            continue;
        }

        if (cury > 0 && arr[curx * n + (cury - 1)] == (arr[curx * n + cury] - 1)) {
            ans[i] = 'e';
            cury--;
            continue;
        }

        if (cury < (n - 1) && arr[curx * n + (cury + 1)] == (arr[curx * n + cury] - 1)) {
            ans[i] = 'w';
            cury++;
            continue;
        }
    }
    for (i = 0; i < cur; ++i)
        printf("%c", ans[i]);

    printf("\n");
    return 0;
}
